// 
// Glow Hott pour télémesure Graupner Hott
// 
// Filtrage pour valeur compte-tours
//
// Auteur : www.thyzoon.fr 
// 

// 
//
#include "Arduino.h"

// Filtre 

word median (word v) {
 
  byte i;
  byte j;
  word mini; 
  word temp;
  
  static word t0,t1,t2;  // Variables de memorisation car le tableau ne peut pas etre static
  word t[3]; 
  static word val_preced =0;  // memorisation valeur
  word filtre;
  
  // Decalage des 3 echantillons
  t2 = t1;
  t1 = t0;
  t0 = v;
  
  // Transfert dans le tableau
  t[0] = t0;
  t[1] = t1;
  t[2] = t2;
  
  // Tri des valeurs par ordre croissant
  
  for (i=0; i<=1; i++) {
    mini = i;
    for (j=i+1; j<=2; j++) {
      if (t [j] < t [mini])
        mini = j;        
    }
    if (mini != i) { // échange
      temp = t [i];
      t [i] = t [mini];
      t [mini] = temp;
    }  
  }
  
  // Valeur médiane : t[1]
  // Moyenne des 2 derniere valeurs
  filtre = (word) ((t[1] + val_preced)/2);
  val_preced = t[1];
  
  return (filtre); 
}

